#ifndef AVERAGE_H
#define AVERAGE_H

// System includes
#include "types.h"

#define Max_N  10 // maximum number of quantities to average

class Average{
  // averages a collection of vector variables that are defined at the same type  // of cell or face, so number of samples NSamp is the same for each.

  public:

  //********data members***************
  int N; //number of (vector) variables to average products of
  real *Avg; //array of averages
  static real *val; //individual values to be averaged
  int NSamp; //number of vals sampled (e.g., cells * times)

  //******** constructor ****************
  Average(int N0) {
    N = N0;
    Avg = new real[N];
   }

  //******** member functions*************
  void init(); //double loop over i&j computes composite index(ij)
  void increment(); //accumulates val into Avg and Avg2
  void normalize(); //divide out number of samples
  void WriteandInit(); //write the average to a file and reinitialize to zero
 };

#endif
