#include "Lowest.h"
#include "Hyst.h"
#include "units.h"
// #include <unistd.h> // for exit?

void Hysteresis::Read(ifstream *File)
{
   *File>>MaxField>>MinField>>Delta>>FieldDir>>MaxHystTime;
   LoopDir = 0;
   TimeSpent = 0;
   //MaxField*=KOe_to_kA_per_meter;
   //MinField*=KOe_to_kA_per_meter;
   //Delta*=KOe_to_kA_per_meter;
   switch (FieldDir)
   {
      case 0: Field = MVector(MaxField, 0.0, 0.0);
              IncField = MVector(Delta, 0.0, 0.0);
              break;
      case 1: Field = MVector(0.0, MaxField, 0.0);
              IncField = MVector(0.0, Delta, 0.0);
              break;
      case 2: Field = MVector(0.0, 0.0, MaxField);
              IncField = MVector(0.0, 0.0, Delta);
              break;
      default: cout<<"error in direction of applied field\n";
               exit(0);
   }
}

void Hysteresis::ChangeField()
{
   if (LoopDir == 0)
      Field -= IncField;
   else
      Field += IncField;
   TimeSpent = 0;
}

void Hysteresis::Chk_cond()
{
// if (Field[FieldDir] < 0) exit(1); // remove it later

   if (Field[FieldDir] < MinField)
      LoopDir = 1;
   else if (Field[FieldDir] > MaxField)
      exit(0);
}

MVector Hysteresis::GetField(real time)
{
   if (TimeSpent < MaxHystTime)
      TimeSpent += time;
   else
   {
      ChangeField();
      Chk_cond();
   }
   return Field;
}
