// file Hyst.h

#include "MVector.h" // lower level
#include "types.h"
#include <fstream>

class Hysteresis
{
   real Delta; //field increament
   MVector IncField; // value of the incremental field 
   real MaxField; //maximum field
   real MinField; //minimum field
   int FieldDir; // direction of the field (0=x, 1=y, 2=z)
   int LoopDir; // direction of the loop (0=>forward, 1=>backward)
   real MaxHystTime; // maximum time to be spent at each field value
   real TimeSpent; // time spent at each field value
   MVector Field; // value of the field at any time
  public:
   //member functions
   void Read(ifstream *File);
   MVector GetField(real time);
   void ChangeField();
   void Chk_cond();
};
