//This is "Random.C" file for generating random numbers and quaternions

//Project includes
#include "Lowest.h"
#include "MVector.h"

// Random number generator.  Not a class, so we don't have to have an instance.
//win32 only: using namespace std; // just for cout, for debugging
unsigned long randint; // this is a global variable, but accessed only here.

float rand1() // returns random number in [0,1]
{// The following code was borrowed from
 // http://support.microsoft.com/default.aspx?scid=kb;en-us;231847
 // and uses nextRandom = ( oldRandom * a + c ) MOD (2^24)
        randint = (randint * 0x43fd43fdL + 0xc39ec3L) & 0xffffffL;
//      cout<<"in rand1, new randint="<<randint<<", real "<<
//           randint / (float)16777216.0<<endl;
        return randint / (float)16777216.0;
}

unsigned long getSeed() // returns seed long
  { return randint; }

  void setSeed(unsigned long seed)
  { randint = seed;}


/* The following produces two Gaussian variates using two random numbers    from a uniform distribution. */

void GenTwoNorVar(real *FirstVariate, real *SecondVariate){ 
real FirstUniformVariate, SecondUniformVariate, LogOfFirst;

// First generate two random numbers between 0 and 1.
  FirstUniformVariate= rand1();
  SecondUniformVariate= rand1();

// Now compute the two random variates with zero mean and unit
// variance using the procedure given in Appendix G of Allen and
// Tildesley.
  LogOfFirst= log(FirstUniformVariate);
  *FirstVariate= sqrt(-2 * LogOfFirst) * cos(2 * M_PI * SecondUniformVariate);
  *SecondVariate=sqrt(-2 * LogOfFirst) * sin(2 * M_PI * SecondUniformVariate);
}
