// This is edge.C file

#include "System.h"
#include "cell.h"

edge::edge()
{
  edge0=NULL;
  edge1=NULL;
  parent=NULL;
 }


edge::edge(MVector* ver1, MVector* ver2)
{
   edge0=NULL;
   edge1=NULL;
   parent=NULL;
   vertexList[0] = ver1;
   vertexList[1] = ver2;
}


edge::~edge() {edge0 = NULL; edge1 = NULL; parent = NULL; delete[] vertexList;}

real edge::getlength()
{
  return fabs(vertexList[0]->its_val(orien)-vertexList[1]->its_val(orien));
}

void edge::print()
{
  if(My->Psetup)
  {
     My->outlog<<"Edge along "<<orien<<" from ["<<vertexList[0]->its_val(0)<<","           <<vertexList[0]->its_val(1)<<","<<vertexList[0]->its_val(2)<<"] to ["           <<vertexList[1]->its_val(0)<<","<<vertexList[1]->its_val(1)<<","
           <<vertexList[1]->its_val(2)<<"]";
    }
}

void edge::edgesplit(int splitPoint1, const MVector &MinCSTemp)   //changed by DMAg
{
   MVector* centerVertex;
   centerVertex = new MVector(*vertexList[0]);
   (*centerVertex)[orien]+=splitPoint1*MinCSTemp[orien];
   if (My->Psetup)
     My->outlog<<"********DMAg: splitPoint = "<<splitPoint1
       <<", vertexList[0] = "<<*vertexList[0]
       <<", centerVertex = "<<*centerVertex
       <<", vertexList[1] = "<<*vertexList[1]<<endl;


   assert(centerVertex);
   edge0 = new edge(vertexList[0],centerVertex);
   assert(edge0);
   edge0->parent = this;
   edge0->orien = orien;

   edge1 = new edge(centerVertex,vertexList[1]);
   assert(edge1);
   edge1->parent = this;
   edge1->orien = orien;
  }

void edge::fixVertexOrder()
{
   if(vertexList[0]->its_val(orien) > vertexList[1]->its_val(orien))
   { MVector* temp = vertexList[1]; // interchange them
     vertexList[1] = vertexList[0];
     vertexList[0] = temp;
    }
}

void edge::sane()
{
  assert ((vertexList[1]->its_val(orien)-vertexList[0]->its_val(orien)) > 0 );
  assert (vertexList[1]->its_val((orien+1)%3) ==
          vertexList[0]->its_val((orien+1)%3));
  assert (vertexList[1]->its_val((orien+2)%3) ==
          vertexList[0]->its_val((orien+2)%3));
  if(edge0)
   assert(edge0->parent == this); //check if the parent is set correctly
  if(edge1)
   assert(edge1->parent == this);
}

MVector DispEdge::absCenter() // absolute center, includes disp
{
  // add two end vertices of edge "ed", divide by 2, then displace by disp
  return My->Displace((*ed->vertexList[0]+*ed->vertexList[1])*0.5,disp);
}

MVector DispEdge::vertexListAbsolute(int i)
{
  return My->Displace(*ed->vertexList[i], disp);
}

void DispEdge::print()
{
  ed->print();
  My->outlog<<", disp is: ["<<disp[0]<<", "<<disp[1]<<", "<<disp[2]<<"]"<<endl;
}

