#ifndef EDGE_H
#define EDGE_H

class MVector;
#include "types.h"

extern int ZeroDisp[3];

class edge{
  public:
  edge *edge0,*edge1;
  edge* parent;
  int orien; //orientation of the edge
  MVector* vertexList[2]; // notation slightly inconsistent, this is pointer to
                          // vertex, but cellList is the DispCell itself
  real getlength(); // return the length of the edge
  void edgesplit(int splitPoint, const MVector &MinCSTemp);//splitPoint was added by DMAg
  void fixVertexOrder();
  edge(MVector*, MVector*);
  edge();
  ~edge();
  void sane(); //sanity check function
  void print();
 };

class DispEdge { // edge displaced relative to something
  public:
  edge *ed;
  int disp[3];
  DispEdge(){ ed=NULL; disp[0]=0; disp[1]=0; disp[2]=0;};
  DispEdge(edge *ed1, int* disp1=ZeroDisp){ ed = ed1;
     disp[0]=disp1[0]; disp[1]=disp1[1]; disp[2]=disp1[2];};
  DispEdge(const DispEdge& DE){ ed = DE.ed;
     disp[0] = DE.disp[0]; disp[1] = DE.disp[1]; disp[2] = DE.disp[2]; };
  ~DispEdge(){ ed = NULL; };
  MVector absCenter(); //consistency
  MVector vertexListAbsolute(int);
  void print();
};

#endif
