//this is face.C file

#include "System.h"
#include "cell.h"
extern System *My;

#define SUCC(x) (x+1)%3

face::face(int normal1, face* parent1)
{
  //constructor
  //default constructor implicit, allocate memory
  face0=NULL;
  face1=NULL;
  parent=parent1;
  assert(cellList[0].cel == NULL);
  assert(cellList[0].disp[0] == 0);
  assert(edgeList[0].ed == NULL);
  assert(edgeList[0].disp[0] == 0);
  //cellList and edgeList should be allocated in DispCell, DispEdge constructor
  centerEdge=NULL;
  normal=normal1;
}

void face::facesplit(int longa, int splitPoint1)  //modified by DMAg
{
  // splits a face, creating children face0 and face1
  // separated along long axis "longa".
  // Should only be called if the face has not been split, debug check:
  assert(face0==NULL); assert(face1==NULL);
  face0=new face(normal,this);
  assert(face0);
  face1=new face(normal,this);
  assert(face1);

//DMA:
//we can find MinCS for this face but cannot do this from edge, so we need to pass
//MinCS to edgesplit
  MVector MinCSTemp;

  if (cellList[0].cel)  //cell on the left is present
    MinCSTemp = cellList[0].cel->rect->MinCS;
  else
    MinCSTemp = cellList[1].cel->rect->MinCS;

  for (int d=0;d<2;d++) // loop over + and - directions (1 & 0) from face
  {                     // to set cellList of touching cells
   if(cellList[d].cel) // there is a cell in the d direction
   {
      if(My->Psetup) My->outlog<<"cellList["<<d<<"] exists"<<endl;
      int laxis = (longa+normal+1)%3;
         //transform "longa" from faceframe to cellframe, then compare it with
         //longaxis of the cell which is in the cellframe
      if(cellList[d].cel->child0 && cellList[d].cel->child1) // has been split
      {
        if(My->Psetup) My->outlog<<"cellList["<<d<<"] has been split"<<endl;
        assert(laxis==cellList[d].cel->longaxis); // we assume long axes same!
//       1        2         3         4         5         6         7
        face0->cellList[d].cel = cellList[d].cel->child0;
        face0->cellList[d].SetDispFrom(cellList[d]);
          // borrow disp from parent cell
        face1->cellList[d].cel = cellList[d].cel->child1;
        face1->cellList[d].SetDispFrom(cellList[d]);
        if(My->Psetup){ My->outlog<<"face0->cellList["<<d<<"] is: "
                        <<face0->cellList[d].cel<<", cell disp is: ["
                        <<face0->cellList[d].disp[0]<<","
                        <<face0->cellList[d].disp[1]<<","
                        <<face0->cellList[d].disp[2]<<"]"<<endl;
                        My->outlog<<"face1->cellList["<<d<<"] is: "
                        <<face1->cellList[d].cel<<", cell disp is: ["
                        <<face1->cellList[d].disp[0]<<","
                        <<face1->cellList[d].disp[1]<<","
                        <<face1->cellList[d].disp[2]<<"]"<<endl; }
       }
      else // cell on side d has NOT been split
      {
        if(My->Psetup) My->outlog<<"cellList["<<d<<"] has not been split"<<endl;
        face0->cellList[d]=cellList[d]; // borrow everything from parent face
        face1->cellList[d]=cellList[d]; // copies all data members of cellList
       }
    } //end if there is a cell in the d direction
   else
   {
      if(My->Psetup) My->outlog<<"cellList["<<d<<"] doesn't exist"<<endl;
      face0->cellList[d].cel=NULL;
      face1->cellList[d].cel=NULL;
    }
  } // end loop over d

  centerEdge=new edge();
  assert(centerEdge);
  int index=0; // count vertices of center edge
  for(int i=0; i<4; i++) // loop 4 edges, split if necessary
  {
    edgeList[i].ed->sane(); // sanity check
    if (longa==(i&1)) //this edge is along the longaxis, must split it.
    { // i&1 is the direction of the edge
      if(!edgeList[i].ed->edge0) // not split yet, must split now
      {
        edgeList[i].ed->edgesplit(splitPoint1, MinCSTemp);  //modified by DMAg
       }
      MVector *V;
      V = new MVector(My->Displace(
             *(edgeList[i].ed->edge0->vertexList[1]), edgeList[i].disp));
      assert(V);
      centerEdge->vertexList[index]=V;
        // record center vertex of this edge as an end of centerEdge
      if(My->Psetup)
       {
        My->outlog<<"centerEdge->vertexList["<<index<<"] is: "
                  <<*centerEdge->vertexList[index]<<endl;
        }

      index++;
      if(My->Psetup) My->outlog<<"index is: "<<index<<endl;
      face0->edgeList[i]=DispEdge(edgeList[i].ed->edge0,edgeList[i].disp);
      face1->edgeList[i]= DispEdge(edgeList[i].ed->edge1,edgeList[i].disp);
      if(My->Psetup) My->outlog<<"finish setting face0 and face1 edgeList"<<endl;
        // set new edges of child faces
     }//end if(along long axis)
    else // not along long axis, just copy to child's edgelist
    {
      if (i&2)
       {
          face1->edgeList[i]=edgeList[i]; // true for i=2,3
         } // this copies parent's displacement as well as edge pointer
      else
       {
          face0->edgeList[i]=edgeList[i]; // do this for i=0,1
        }
      if(My->Psetup) My->outlog<<"face not along long axis, set face edgelist"<<endl;
     } //end else (not along long axis
   } //end loop over i
  assert (index == 2); //sanity check, make sure we set 2 vertices
      //Now set orientation of center edge. The face normal, the long axis, and
      // this edge orientation are 3 mutually perpendicular directions,
      // so we just have to determine the order (123 or 321).
      // (longa+normal+1)%3 change longa from face frame back to cell frame
  if(((longa+normal+1)%3) == SUCC(normal))
      //order is (normal,long,edge) or cyclic permutation
    centerEdge->orien = SUCC((longa+normal+1)%3);
  else//order is backwards: edge, long, normal
    centerEdge->orien = SUCC(normal);
  centerEdge->fixVertexOrder();
  centerEdge->print();
     // Now we must insert CenterEdge into the edge lists of face0 and face1.
     // For face1, centerEdge is on the "low" side (high bit of index = 0)
     // and edge direction is perpendicular to long axis (low bit = 1-longa):
  face1->edgeList[1-longa] = DispEdge(centerEdge); // 1-longa is short axis.
     // for face0, centerEdge is on "high" (high bit=1) side, so we add 2:
  face0->edgeList[3-longa] = DispEdge(centerEdge);
     //set face center to determine cell center
  face0->setFaceCenter();
  face1->setFaceCenter();
  sane(); //sanity check
  face0->sane(); //sanity check for child faces.
  face1->sane();
  if(My->Psetup) My->outlog<<"finish facesplit()"<<endl;
}

void face::getlongedge(int& lengthInt, int& dir)
{
  MVector MinCSTemp;

  lengthInt = 0; dir =0;

  if (cellList[0].cel)
    MinCSTemp = cellList[0].cel->rect->MinCS;
  else
    MinCSTemp = cellList[1].cel->rect->MinCS;

  for (int i=0; i<4; i++)
    { 
      int dir1 = edgeList[i].ed->orien;  //orientation of the edge
      int len1 = (int) (edgeList[i].ed->getlength()/MinCSTemp[dir1] +0.1);
      if((len1>lengthInt) || ((len1==lengthInt) && (dir1 < dir)))
      {
        lengthInt=len1;
        dir = dir1;
      }
    }
}

void face::sane(){
  //edgeList[0].print(); edgeList[1].print();
  //edgeList[2].print(); edgeList[3].print();
  if(face0)
   assert(face0->parent == this);
  if(face1)
   assert(face1->parent == this);
  for (int i=0; i<4; i++) edgeList[i].ed->sane();
  assert(edgeList[0].vertexListAbsolute(0)==edgeList[1].vertexListAbsolute(0));
  assert(edgeList[2].vertexListAbsolute(0)==edgeList[1].vertexListAbsolute(1));
  assert(edgeList[2].vertexListAbsolute(1)==edgeList[3].vertexListAbsolute(1));
  assert(edgeList[3].vertexListAbsolute(0)==edgeList[0].vertexListAbsolute(1));
  // vertexListAbsolute vectors are all absolute, not relative
 }

void face::setFaceCenter(){
  faceCenter=My->Displace(*(edgeList[0].ed->vertexList[0]),edgeList[0].disp);
  //sets faceCenter=0-th vertex of 0-th edge,displaced if the edge is displaced.
  faceCenter+=My->Displace(*(edgeList[2].ed->vertexList[1]),edgeList[2].disp);
  faceCenter/=2.0;
  //if (My->Psetup) My->outlog<<"found face center, "<<faceCenter<<endl;
 }

DispFace::DispFace(const DispFace& DF)
{
  myFace = DF.myFace;
  out = DF.out;
  disp[0] = DF.disp[0]; disp[1] = DF.disp[1]; disp[2] = DF.disp[2];
  owned = 0;  //DMA
}

DispFace::DispFace(face* myFace1, int out1, int *disp1)
{ // or could assume disp=0
  myFace = myFace1;
  out = out1;
  disp[0]=disp1[0]; disp[1]=disp1[1]; disp[2]=disp1[2];
  owned=0; //DMA
}

MVector DispFace::absCenter()
  // computes absolute position of center (adds disp)
{
  MVector V=myFace->faceCenter;
  return My->Displace(V,disp);
}


