 			//int3.C file
#include "Lowest.h" 
#include "int3.h"
#include <fstream> // needed for ostream?
class Kernel; // don't need entire FMM.h

void int3::orient () // rearrange values so that 0<=values[i] <=values[i+1]
{
  for (int i=0; i<3; i++)
    values[i] = abs(values[i]);   //all numbers should be positive

//using bubble sorting:
  int temp; //temporary storage for swaping two numbers
  do {
    for (int i=0; i<2; i++)
      if (values[i] > values[i+1])  //need to swap them
      {
        temp = values[i];
        values[i] = values[i+1];
        values[i+1] = temp;
      }
  } while ((values[0] > values[1]) || (values[1] > values[2]));
  assert ((values[0] <= values[1]) && (values[1] <= values[2]));
}
   
//DMAk
//returns 1 if the values are (0,0,0)
int int3::isZero() const
{
  return ((values[0]==0) && (values[1]==0) && (values[2]==0));
}

ostream& operator<<(ostream &out, const int3 &i) //overloaded <<operator for int3 class
{
  out<<" ("<<i.values[0]<<' '<<i.values[1]<<' '<<i.values[2]<<") ";
  return out;
}


int3 int3::operator- (const int3& iRight) const
{
  int3 result;

  for (int i=0; i<3; i++)
    result.values[i] = values[i] - iRight.values[i];

  return result;
}


int3 int3::operator+ (const int3& iRight) const
{
  int3 result;
  
  for (int i=0; i<3; i++)
    result.values[i] = values[i] + iRight.values[i];

  return result;
}


int3 int3::operator/ (const int& r) const
{
  int3 result;

  for (int i=0; i<3; i++)
  {
    assert ((values[i]%r) == 0);
    result.values[i] = values[i]/r;
  }

  return result;
}

const int3 & int3::operator= (const int3& right)
{
  for (int i = 0; i<3; i++)
    values[i] = right.values[i];

  return *this;
}


