// file int3.h , needed only for FMM

#ifndef INT3_H
#define INT3_H
#include <fstream>
// #include <assert.h>
 
using namespace std;

 class int3
{
  friend ostream &operator<<(ostream&, const int3&);
public:
  int values[3]; //the displacement of the source cell. Must be integer to be
                 //used as a key for an STL map

//****************** member functions *******************
  int3(int x=0, int y=0, int z=0) //constructor
    {values[0]=x; values[1]=y; values[2]=z;}
  int3 (const int3& right)  //copy constructor
    {values[0]=right.values[0]; values[1]=right.values[1];
     values[2]=right.values[2];
  }
  void orient ();  //DMAk - orient the key so that 0<=x<=y<=z
  int isZero () const;  //DMAk - returns 1 if it is (0,0,0)
  int sum() const //returns values[0]+values[1]+values[2]
  { return values[0]+values[1]+values[2];}
//******************* operations ************************
  int3 operator- (const int3&) const;  //subtraction operator
  int3 operator+ (const int3&) const;  //addition operator
  int3 operator/ (const int&) const;  //division operator
  const int3 & operator= (const int3&); //assignment
  int& operator[](int i) { assert ((i<3) && (i>=0)); return values[i];}
  const int& operator[](int i) const {assert ((i<3) && (i>=0)); return values[i];}
};

#endif //INT3_H

