//this is main.C file

#include "Lowest.h"
#include "System.h"
#include "FMM.h"
#include "cell.h"

extern int ZeroDisp[3];

#ifdef GRAPHICS 
#include "display.h"
//changed by DMAm
static void mySensorCallback (void *data, SoSensor *)
{   //cout<<"Entering mySensorCallback"<<endl;
    if (((System*)data)->HandleCallback())
    return; //if returns 1 display scene & repeat
  else
    exit(0);
}
#endif



int main(int argc,char **argv){
    ofstream Errorlog; // for startup errors

    Errorlog.open("error.log"); 
	if(Errorlog) cout<<"opened"; else cout<<"Failed to open"; 
	cout<<" error log"<<endl;
	Errorlog<<"This file logs errors in startup."<<endl;
	Errorlog<<"Starting with "<<argc<<
		" arguments (2 means script file specified)"<<endl;

  cout<<"Starting micromagnetics program AlaMag"<<endl;

   string ParFileString; // empty string
   if (argc>1) // then had filename on command line, turn into string:
   {for(int argi=1;;argi++) 
      {ParFileString.append(argv[argi]); 
	   if ((argi+1)==argc) break; // out of for loop
	   ParFileString+=' ';} // in case there are blanks in file or dir names!
	  cout<<"From command line, read script file name:";
	}
   else // no filelname, use default
   {ParFileString=string("default.script"); 
   cout<<"Using default input:";
   }
  cout<<ParFileString<<endl;
  Errorlog<<"will read "<<ParFileString<<endl;
  

  // open parameter file on command line, or default:  
  My->paramFile.open(ParFileString.c_str()); // open requires c_string
  if(My->paramFile) Errorlog<<"Opened"; else Errorlog<<"Cannot open";
  Errorlog<<" script file "<<ParFileString<<endl; 
  if(!My->paramFile) MYEXIT;

  // now parse ParFileString to get runID; erase up to last backslash
  size_t posn=ParFileString.find_last_of("\\",ParFileString.length());
  if (posn<ParFileString.length()) ParFileString.erase(0,posn+1);

  string Suffix = ParFileString.substr(ParFileString.length()-7,7);
  if (Suffix.compare(".script")) // compare=0 if same, else exit
     {Errorlog<<"Input file suffix should be .script"<<endl; MYEXIT;}
  My->runID = ParFileString.erase(ParFileString.length()-7,7); // removes .script from end
  cout<<"Set runid = "<<My->runID<<endl;
  Errorlog<<"Set runid = "<<My->runID<<", about to call System::init()"<<endl;
 

  My->ReadScript(); // ReadScript() is in file System.cpp; reads paramFile
  My->prepareExit(); //close files and output final information Shuxia
  cout<<"Program terminated"<<endl;
  return 0;  //successful program completion
} // end program main

